::mods_registerMod("mod_breditor", 1.0, "Breditor");

::mods_queue("mod_breditor", null, function() {
/* 	::mods_registerJS("world_breditor_screen.js");
 	::mods_registerCSS("world_breditor_screen.css"); */

	
	::mods_hookNewObjectOnce("states/world_state", function(o) {
	  local ws_init_ui = o.onInitUI;
	  o.onInitUI = function()
	  {
		ws_init_ui();
		this.m.WorldBreditorScreen <- this.new("scripts/ui/screens/world/world_breditor_screen");
		this.m.WorldBreditorScreen.setOnClosePressedListener(this.town_screen_main_dialog_module_onLeaveButtonClicked.bindenv(this));
		this.initLoadingScreenHandler();
	  }
	});
	
	::mods_hookNewObjectOnce("states/world_state", function(o) {
	  local ws_destroy_ui = o.onDestroyUI;
	  o.onDestroyUI = function()
	  {
		ws_destroy_ui();
		this.m.WorldBreditorScreen.destroy();
		this.m.WorldBreditorScreen = null;
	  }
	});
	
	::mods_hookNewObjectOnce("ui/screens/tooltip/tooltip_events", function(o) {
	  local queryTooltipData = o.general_queryUIElementTooltipData;
	  o.general_queryUIElementTooltipData = function(entityId, elementId, elementOwner)
	  {
		local tooltip = queryTooltipData(entityId, elementId, elementOwner);
		if(tooltip != null) return tooltip;
		if(elementId == "breditor-talent-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "才能"
			},
			{
			  id = 2,
			  type = "description",
			  text = "单击循环才能等级. 0-1-2-3-0-1-2-3-..."
			},
		  ];
		}
/* 		else if(elementId == "breditor-stats-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "属性"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "相应属性的当前值(不包括任何特征或装备的加成) // 此特定背景的角色的相应属性的最大可能起始值。"
			}, 
		  ];
		} */
		else if(elementId == "breditor-xp-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "+1 等级"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "为当前兄弟提供达到下一个等级所需的经验。"
			}, 
		  ];
		}
		else if(elementId == "breditor-pp-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "特技(Perk)点数"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "你的特技(Perk)点数。"
			}, 
		  ];
		}
		else if(elementId == "breditor-op-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "遗忘特技(Perk)"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "点击饮用遗忘药水，遗忘你的特技(Perk)。"
			}, 
		  ];
		}
		else if(elementId == "breditor-yf-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "青春之泉"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "点击此处饮用青春之泉的水。它会治愈你的伤痛，改善你的情绪。"
			}, 
		  ];
		}
		else if(elementId == "breditor-bg-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "背景"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "将特征面板切换到背景模式，允许您更改背景。也可以换回来。"
			}, //\n[b][color=" + this.Const.UI.Color.NegativeValue + "]警告! 改变背景可能会改变你的等级，甚至降低它。有些背景就是这样的.[/color][/b]
		  ];
		}
		else if(elementId == "breditor-background-tooltip")
		{
		  local bgtemp = this.new(elementOwner);
		  return [
			{
			  id = 1,
			  type = "title",
			  text = bgtemp.m.Name,
			},
 			{
			  id = 2,
			  type = "description",
			  text = bgtemp.m.BackgroundDescription,
			}, 
		  ];
		}
		else if(elementId == "breditor-nicategory-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "可命名物品的类别"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "选择可命名物品的类别."
			}, 
		  ];
		}
		else if(elementId == "breditor-niupdateimage-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "重掷"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "随机生成物品(可用来寻找喜欢的物品)."
			}, 
		  ];
		}
		else if(elementId == "breditor-nifinalize-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "添加进仓库"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "将当前生成的物品添加到您的仓库里."
			}, 
		  ];
		}
		else if(elementId == "breditor-partystrength-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "团队战力"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "计算你的:\n- 团队战力\n- 合同难度系数\n- 敌人难度系数"
			}, 
		  ];
		}
		else if(elementId == "breditor-mirrorbattle-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "镜像战斗"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "和你团队的克隆人作战!\n(不用于实际游戏, 仅用于测试/娱乐)"
			}, 
		  ];
		}
		else if(elementId == "breditor-haircolor-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "头发颜色"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "头发颜色与导出导入功能无关. 如果你在上面字符框里粘贴 (CTRL+V) 或输入一个6位字符的颜色代码，然后按此按钮，可把当前队友头发染成对应颜色. \n发色无法导出、导入或撤消，只能用其他染料替换。染料是你在理发店选择的颜色上面的第二层，所以你不能把黑发染成白色 (使用白色 ffffff = 完全没有染料)."
			}, 
		  ];
		}
		else if(elementId == "breditor-beardcolor-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "胡须颜色"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "胡须颜色与导出导入功能无关. 如果你在上面字符框里粘贴 (CTRL+V) 或输入一个6位字符的颜色代码，然后按此按钮，可当前队友胡须染成对应颜色. \n胡须颜色无法导出、导入或撤消，只能用其他染料替换。染料是你在理发店选择的颜色上面的第二层，所以你不能把黑胡子染成白色 (使用白色 ffffff = 完全没有染料)."
			}, 
		  ];
		}
		else if(elementId == "breditor-impexpstats-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "导出主要数据"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "是 或 否 - 是否导出当前队友的[b][color=" + this.Const.UI.Color.PositiveValue + "]主要数据[/color][/b](特别是导入导出会影响的属性、特性、perks、等级、经验、外貌和才能). 单击此处进行更改."
			}, 
		  ];
		}
		else if(elementId == "breditor-impexplifestats-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "导出生涯数据"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "是 或 否 - 是否导出当前队友的[b][color=" + this.Const.UI.Color.PositiveValue + "]生涯数据[/color][/b] - 杀敌数、战斗次数等。单击此处进行更改."
			}, 
		  ];
		}
		else if(elementId == "breditor-impexpgear-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "导出装备数据"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "是 或 否 - 是否导出当前队友的[b][color=" + this.Const.UI.Color.PositiveValue + "]装备数据[/color][/b]. 它只保存物品大类别的标准属性数据，不保存特殊物品的特殊属性数据. 单击此处进行更改."
			}, 
		  ];
		}
		else if(elementId == "breditor-broexport-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "导出"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "点击生成包含当前队友数据的字符串。然后点击上面字符框里的字段，按CTRL+A，然后按CTRL+C将其保存到剪贴板."
			}, 
		  ];
		}
		else if(elementId == "breditor-broimport-tooltip")
		{
		  return [
			{
			  id = 1,
			  type = "title",
			  text = "导入"
			},
 			{
			  id = 2,
			  type = "description",
			  text = "在使用之前，先用CTRL+A，然后使用CTRL+V将包含有关队友信息的字符串粘贴到上面字符框里（如果还没有所需的字符串）. [b][color=" + this.Const.UI.Color.NegativeValue + "]确保上面字符框中没有其他字符，只有字符串原样.[/color][/b]\n然后按下此按钮，您当前选择的兄弟将被替换.\n[b][color=" + this.Const.UI.Color.NegativeValue + "]不建议在不同版本的游戏之间导出导入兄弟，更不用说在不同的修改版本之间了.[/color][/b]"
			}, 
		  ];
		}
		return null;
	  }
	});
	
	::mods_hookNewObjectOnce("states/world_state", function(o) {
	  local keyHandler = o.helper_handleContextualKeyInput;
	  o.helper_handleContextualKeyInput = function(key)
	  {
		if(!keyHandler(key) && key.getState() == 0)
		{
		  if (key.getKey() == 34 && key.getModifier() == 1) //SHIFT + X
			if (!this.m.MenuStack.hasBacksteps() && !this.m.CharacterScreen.isVisible() && !this.m.WorldTownScreen.isVisible() && !this.m.EventScreen.isVisible() && !this.m.EventScreen.isAnimating())
			{
				this.setAutoPause(true);
				this.m.CustomZoom = this.World.getCamera().Zoom;
				this.World.getCamera().zoomTo(1.0, 4.0);
				this.Tooltip.hide();
				this.m.WorldScreen.hide();
				this.m.WorldBreditorScreen.show();
				this.Cursor.setCursor(this.Const.UI.Cursor.Hand);
				this.m.MenuStack.push(function ()
				{
					this.World.getCamera().zoomTo(this.m.CustomZoom, 4.0);
					this.m.WorldBreditorScreen.hide();
					this.m.WorldScreen.show();
					this.Cursor.setCursor(this.Const.UI.Cursor.Hand);
					this.setAutoPause(false);
				}, function ()
				{
					return !this.m.RelationsScreen.isAnimating();
				});
				return true;
			}
		}
	  }
	});
	/*
	::mods_hookNewObject("skill/traits/glorious_endurance_trait", function(o) {
		o.m.ID = "trait.glorious_endurance";
	});
	
	::mods_hookNewObject("skill/traits/glorious_quickness_trait", function(o) {
		o.m.ID = "trait.glorious_quickness";
	});
	
	::mods_hookNewObject("skill/traits/glorious_resolve_trait", function(o) {
		o.m.ID = "trait.glorious_resolve";
	});
	*/
});


